<?php
/*----------------------------------------------------+
| LIBRARY MANAGEMENT SYSTEM
|-----------------------------------------------------+
| A LIBRARY RESOURCE MANAGER
| BY EDAN BOY PEDRAGOSA "alias" HACKERSOFT
| Web: http://hackersoft.ath.cx/dev/
| email: edan@niva-is.net
|----------------------------------------------------+
| Released under the terms and conditions of
| the GNU General Public License
+----------------------------------------------------*/
require_once "../../maincore.php";
require_once BASEDIR."subheader.php";

	if (file_exists(INFUSIONS."library_manager/locale/".$settings['locale'].".php")) {
		require_once INFUSIONS."library_manager/locale/".$settings['locale'].".php";
	} else {
		require_once INFUSIONS."library_manager/locale/English.php";
	}

	if (file_exists(INFUSIONS."library_manager/locale/arrays/".$settings['locale'].".php")) {
		require_once INFUSIONS."library_manager/locale/arrays/".$settings['locale'].".php";
	} else {
		require_once INFUSIONS."library_manager/locale/arrays/English.php";
	}

require INFUSIONS."library_manager/includes/functions.php";

require_once INFUSIONS."library_manager/includes/accessfunctions.php";
$libraryConfig = dbarray(dbquery("SELECT * FROM ".$db_prefix."library_configuration"));
$user_groups = getusergroups();

if (iADMIN) {
	$curGroups = "101.102".$userdata['user_groups'];
} elseif (iMEMBER){
	$curGroups = "101".$userdata['user_groups'];
}

if (iSUPERADMIN || CheckAccessLevel($curGroups,$libraryConfig['BorrowingMGA'])) {
	require_once INFUSIONS."library_manager/includes/navigation.php";

	if (!$confirmActivity) { //do this if not yet to confirm activity
		if (!$checkPatronResource) { //ask for the data
			//ASK FOR RESOURCE CODE AND PATRON CODE
				require_once INFUSIONS."library_manager/includes/queryPatronResource.php";
			//END ASK FOR RESOURCE CODE AND PATRON CODE

		} elseif ($_POST['patronCode']=="" || $_POST['resourceCode']=="") {
			//ASK FOR RESOURCE CODE AND PATRON CODE
				require_once INFUSIONS."library_manager/includes/queryPatronResource.php";
			//END ASK FOR RESOURCE CODE AND PATRON CODE
				tablebreak();
		
				if ($_POST['resourceCode']=="" && $_POST['patronCode']<>"") {
					opentable ($locale['lib138']);
							echo $locale['lib410'];
					closetable();
				} elseif ($_POST['patronCode']=="" && $_POST['resourceCode']<>"") {
					opentable ($locale['lib139']);
							echo $locale['lib411'];
					closetable();
				} else {
					opentable ($locale['lib140']);
							echo $locale['lib412'];
					closetable();
				}
			//END ASK FOR RESOURCE CODE AND PATRON CODE
		} else { //show confirm transaction form

				$patronCode = trim(stripinput($_POST['patronCode']));
				$resourceCode = trim(stripinput($_POST['resourceCode']));
				$resultP = dbquery("SELECT * FROM ".$db_prefix."library_patrons WHERE patron_Code='$patronCode'");
				$patron = dbarray($resultP);
				$PatronInfo = QueryPatronInfo($patron['patron_SiteUserName'],$db_prefix);
				$ResourceInfo = QueryResources ($resourceCode,$db_prefix);
				$PatronResourceCode = $patronCode . $resourceCode;

						if ($ResourceInfo['Resource_Title']<>"") {
							if (dbrows($resultP)<> 0 ) {
								$result = dbquery("SELECT * FROM ".$db_prefix."library_borrowing WHERE ResourceCode='$resourceCode'");
								if (dbrows($result) == 0) {
									$TransactionCaption = $locale['lib145a'];
									$AvailableCopies = $ResourceInfo['Resource_AvailableCopies'] - $ResourceInfo['Resource_BorrowedCopies'];
									include INFUSIONS."library_manager/includes/confirmTransaction.php";
								} else {
									//ASK FOR RESOURCE CODE AND PATRON CODE
										require_once INFUSIONS."library_manager/includes/queryPatronResource.php";
									//END ASK FOR RESOURCE CODE AND PATRON CODE
										tablebreak();
										opentable ($locale['lib141']);
												echo $locale['lib413'];
										closetable();
									//END ERROR MESSAGE
								}

							} else {
								//ASK FOR RESOURCE CODE AND PATRON CODE
									require_once INFUSIONS."library_manager/includes/queryPatronResource.php";
								//END ASK FOR RESOURCE CODE AND PATRON CODE
									tablebreak();
									opentable ($locale['lib142']);
											echo $locale['lib414'];
									closetable();
								//END ERROR MESSAGE
							}
						} else {
								//ASK FOR RESOURCE CODE AND PATRON CODE
									require_once INFUSIONS."library_manager/includes/queryPatronResource.php";
								//END ASK FOR RESOURCE CODE AND PATRON CODE
									tablebreak();
									opentable ($locale['lib143']);
											echo $locale['lib415'];
									closetable();
								//END ERROR MESSAGE
						}
		} //end first condition

	} elseif ($cancelActivity) {
		redirect (INFUSIONS."library_manager/borrow.php");
	} else { //if activity is confirmed
		if ($LoanValue<>0 || is_numeric($LoanValue)) {
			$result = dbquery("SELECT * FROM ".$db_prefix."library_patrons WHERE patron_Code='$patronCode'");
			$patron = dbarray($result);
			$PatronInfo = QueryPatronInfo($patron['patron_SiteUserName'],$db_prefix);

			$BorrowCountP = $PatronInfo['Resource_BorrowCount'] + 1;

			$ResourceInfo = QueryResources ($resourceCode,$db_prefix);
			$AvailableCopies = $ResourceInfo['Resource_AvailableCopies'] - $ResourceInfo['Resource_BorrowedCopies'];

			$PatronResourceCode = $patronCode . $resourceCode;
			$SiteUserName = $patron['patron_SiteUserName'];
			$Activity = 'Borrowing';

			//get date in human format		
			$ActivityDate = time();
			$PatronResourceCodeDate = $patronCode . $resourceCode . $ActivityDate;
			$DueDate = ComputeDueDate($LoanValue,$LoanDuration,$ActivityDate);

			$result = dbquery("SELECT * FROM ".$db_prefix."library_borrowing WHERE PatronResourceCode='$PatronResourceCode'");
				if (dbrows($result) == 0) {
					//record to the borrowing table
					$result = dbquery("INSERT INTO ".$db_prefix."library_borrowing (PatronResourceCode, PatronCode, SiteUserName,ActivityDate,DueDate,ResourceCode,DurationBasis) 
					VALUES ('$PatronResourceCode' , '$patronCode', '$SiteUserName', '$ActivityDate','$DueDate','$resourceCode', '$LoanDuration')");

					//record it to the history table
					$result = dbquery("INSERT INTO ".$db_prefix."library_history (PatronResourceCodeDate, PatronCode, SiteUserName, Activity, ActivityDate, DueDate, ResourceCode,DurationBasis) 
					VALUES ('$PatronResourceCodeDate' , '$patronCode', '$SiteUserName', '$Activity', '$ActivityDate','$DueDate','$resourceCode','$LoanDuration')");
					
					$BorrowedCopies = $ResourceInfo['Resource_BorrowedCopies'] + 1;
					$BorrowCount = $ResourceInfo['Resource_BorrowCount'] + 1;
					$LastPatronCode = $patronCode;

					IncrementPatronBC($patronCode,$BorrowCountP,$db_prefix);

					UpdateBorrowedCopies($ResourceInfo['Resource_ISBN'],$BorrowedCopies,$db_prefix);

					UpdateResourceStatus($ResourceInfo['Resource_Code'],'Out',$LastPatronCode,$BorrowCount,$db_prefix);

				} else {
					$result = dbquery("UPDATE ".$db_prefix."library_borrowing SET PatronResourceCode='$PatronResourceCode', PatronCode='$patronCode', SiteUserName='$SiteUserName',ActivityDate='$ActivityDate',DueDate='$DueDate', ResourceCode='$resourceCode', DurationBasis='$LoanDuration' WHERE PatronResourceCode='$PatronResourceCode'");
				} //end if dbquery no match

				//ASK FOR RESOURCE CODE AND PATRON CODE
					require_once INFUSIONS."library_manager/includes/queryPatronResource.php";
				//END ASK FOR RESOURCE CODE AND PATRON CODE
					$result = dbquery("SELECT * FROM ".$db_prefix."library_patrons WHERE patron_Code='$patronCode'");
					$patron = dbarray($result);
					$PatronInfo = QueryPatronInfo($patron['patron_SiteUserName'],$db_prefix);
					$ResourceInfo = QueryResources ($resourceCode,$db_prefix);
					$AvailableCopies = $ResourceInfo['Resource_AvailableCopies'] - $ResourceInfo['Resource_BorrowedCopies'];

					$PatronResourceCode = $patronCode . $resourceCode;
					$SiteUserName = $patron['patron_SiteUserName'];
					$Activity = 'Borrowing';

					$ActivityDate = time();
					$PatronResourceCodeDate = $patronCode . $resourceCode . $ActivityDate;

					tablebreak();
					opentable ($locale['lib135']);
						echo "<table width='100%'>
						<tr>
							<td align='right'>".$locale['lib366']."</td><td><b>" . $PatronInfo['extra_userinfo_FirstName'] . "&nbsp;" . $PatronInfo['extra_userinfo_LastName'] . "</b></td>
						</tr>
						<tr>
							<td align='right'>".$locale['lib367']."</td><td><b> $SiteUserName</b> </td>
						</tr>
						<tr>
							<td align='right'>".$locale['lib368']."</td><td><b> " . date("D F d, Y h:i:s A", $ActivityDate) . "</b></td>
						</tr>

						<tr>
							<td align='right'>".$locale['lib369']."</td><td><b> " . date("D F d, Y h:i:s A", $DueDate) . "</b></td>
						</tr>

						<tr>
							<td colspan='2'><hr></td>
						</tr>


						<tr>
							<td align='right'>".$locale['lib322']."</td><td><b>" . $ResourceInfo['Resource_Title'] ."</b></td>
						</tr>
						<tr>
							<td align='right'>".$locale['lib318']."</td><td><b>" . $ResourceInfo['Resource_Code'] ."</b></td>
						</tr>
						<tr>
							<td align='right'>".$locale['lib323']."</td><td><b>" . $ResourceInfo['Resource_Authors'] ."</b></td>
						</tr>

						<tr>
							<td align='right'>".$locale['lib370']."</td><td><b>" . $ResourceInfo['Resource_AvailableCopies'] ."</b></td>
						</tr>

						<tr>
							<td align='right'>".$locale['lib371']."</td><td><b>" . $ResourceInfo['Resource_BorrowedCopies'] ."</b></td>
						</tr>

						<tr>
							<td align='right'>".$locale['lib372']."</td><td><b>" . $AvailableCopies ."</b></td>
						</tr>

						</table>";

					closetable();

		} else {
				$result = dbquery("SELECT * FROM ".$db_prefix."library_patrons WHERE patron_Code='$patronCode'");
				$patron = dbarray($result);
				$PatronInfo = QueryPatronInfo($patron['patron_SiteUserName'],$db_prefix);
				$ResourceInfo = QueryResources ($resourceCode,$db_prefix);
				$AvailableCopies = $ResourceInfo['Resource_AvailableCopies'] - $ResourceInfo['Resource_BorrowedCopies'];

				$PatronResourceCode = $patronCode . $resourceCode;
				$SiteUserName = $patron['patron_SiteUserName'];
				$Activity = 'Borrowing';

				//get date in human format		
				$ActivityDate = time();
				$PatronResourceCodeDate = $patronCode . $resourceCode . $ActivityDate;

				include INFUSIONS."library_manager/includes/confirmTransaction.php";
				tablebreak();
				opentable ($locale['lib144']);
						echo $locale['lib416'];
				closetable();
				//END ERROR MESSAGE
		}
	}
} else {
	redirect(BASEDIR."index.php");
}//Access Denied


require_once BASEDIR."footer.php";
?>